﻿using System;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;
using Celeste.Mod.Entities;
using Monocle;
using Microsoft.Xna.Framework;
using MonoMod.Utils;

namespace Celeste.Mod.FarewellAdvent.Entities
{
    [CustomEntity("ricky06/BossSingleAttackTrigger")]
    [Tracked]
    public class BossSingleAttackTrigger : Trigger
    {
        private Level level;
        private ConquerorDash boss;
        public BossSingleAttackTrigger(EntityData data, Vector2 offset)
            : base(data, offset)
        {

        }

        public override void Awake(Scene scene)
        {
            base.Awake(scene);
            level = SceneAs<Level>();
        }

        public override void OnEnter(Player player)
        {
            if (boss == null)
            {
                Add(new Coroutine(SpawnBossThenDespawn()));
            }
        }

        private IEnumerator SpawnBossThenDespawn()
        {
            Scene.Add(boss = new ConquerorDash());
            yield return 3f;
            boss.RemoveSelf();
            Scene.Remove(boss);
        }
    }
}
